//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3A928ABE00C6.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3A928ABE00C6.cm

//## begin module%3A928ABE00C6.cp preserve=no
//## end module%3A928ABE00C6.cp

//## Module: ParameterLink%3A928ABE00C6; Package specification
//## Subsystem: XSModel::Parameter%367691A8CEA0
//	/local/data/verisB/dorman/Xspec/src/XSModel/Parameter
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Parameter/ParameterLink.h

#ifndef PARAMETERLINK_H
#define PARAMETERLINK_H 1

//## begin module%3A928ABE00C6.additionalIncludes preserve=no
//## end module%3A928ABE00C6.additionalIncludes

//## begin module%3A928ABE00C6.includes preserve=yes
//## end module%3A928ABE00C6.includes

// Error
#include <XSUtil/Error/Error.h>
// map
#include <map>
// LinkExpression
#include <XSUtil/Parse/LinkExpression.h>

//## Modelname: XSModel::GlobalContainer%3E42929A0210
namespace XSContainer {
    class ModelContainer;

} // namespace XSContainer

//## begin module%3A928ABE00C6.declarations preserve=no
#include <iosfwd>
//## end module%3A928ABE00C6.declarations

//## begin module%3A928ABE00C6.additionalDeclarations preserve=yes
class Parameter;
//## end module%3A928ABE00C6.additionalDeclarations


//## begin ParameterLink%362F93D90212.preface preserve=yes
//## end ParameterLink%362F93D90212.preface

//## Class: ParameterLink%362F93D90212
//	The ParameterLink class contains information needed to
//	express arbitrary links between parameters. its
//	attributes are
//
//	1) a std::map instance indexing parameter numbers
//	to parameter pointers.
//
//
//	2) an expression containing the relationship between
//	*this and the parameters in the map.
//## Category: XSModel::Parameter%36349D8902D7
//## Subsystem: XSModel::Parameter%367691A8CEA0
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: UUUU%3A9E79CF017C;XSContainer::ModelContainer { -> F}
//## Uses: <unnamed>%3C03B3DF02AC;std::map { -> }
//## Uses: <unnamed>%3D404CB8025F;SwitchParam { -> }
//## Uses: <unnamed>%3D404CC1032E;ScaleParam { -> }

class ParameterLink 
{
  //## begin ParameterLink%362F93D90212.initialDeclarations preserve=yes
  //## end ParameterLink%362F93D90212.initialDeclarations

  public:
    //## Class: InvalidInput%39172B389DE0
    //## Category: XSModel::Parameter%36349D8902D7
    //## Subsystem: XSModel::Parameter%367691A8CEA0
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class InvalidInput : public YellowAlert  //## Inherits: <unnamed>%39172B907898
    {
      public:
        //## Constructors (specified)
          //## Operation: InvalidInput%39172B593BF0
          InvalidInput (const string& msg);

      protected:
      private:
      private: //## implementation
    };

  private:
    //## Class: ParseFailure%392168DC02BC; private
    //	thrown if a link expression has slipped through all the
    //	checks with invalid syntax. RedAlert fatal.
    //## Category: XSModel::Parameter%36349D8902D7
    //## Subsystem: XSModel::Parameter%367691A8CEA0
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class ParseFailure : public RedAlert  //## Inherits: <unnamed>%3921695600F4
    {
      public:
        //## Constructors (specified)
          //## Operation: ParseFailure%3921691E001A
          ParseFailure (const string& msg);

      protected:
      private:
      private: //## implementation
    };

  public:
    //## Class: DivideCheck%3921A538032A
    //## Category: XSModel::Parameter%36349D8902D7
    //## Subsystem: XSModel::Parameter%367691A8CEA0
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class DivideCheck : public YellowAlert  //## Inherits: <unnamed>%3921A58601FE
    {
      public:
        //## Constructors (specified)
          //## Operation: DivideCheck%3921A58A02FA
          DivideCheck (const string& msg);

      protected:
      private:
      private: //## implementation
    };

    //## Class: NoValidParametersInExpression%3AB8CDD900FB
    //## Category: XSModel::Parameter%36349D8902D7
    //## Subsystem: XSModel::Parameter%367691A8CEA0
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class NoValidParametersInExpression : public YellowAlert  //## Inherits: <unnamed>%3AB8CE9E0092
    {
      public:
        //## Constructors (specified)
          //## Operation: NoValidParametersInExpression%3AB8CDF50226
          NoValidParametersInExpression (const string& msg);

      protected:
      private:
      private: //## implementation
    };

    //## Constructors (generated)
      ParameterLink(const ParameterLink &right);

    //## Constructors (specified)
      //## Operation: ParameterLink%3905CA752C60
      //	Constructor for parameter link class.
      //
      //	Arguments are a string, from which is constructed
      //	an Expression instance.
      //
      //	The isBoolean argument allows the code
      //	to flag when the link is applied to a SwitchParam that
      //	has a much more restrictive link syntax
      ParameterLink (const string& linkExpression, const Parameter* p, bool isBoolean = false);

    //## Destructor (generated)
      ~ParameterLink();

    //## Assignment Operation (generated)
      ParameterLink & operator=(const ParameterLink &right);


    //## Other Operations (specified)
      //## Operation: independentParameter%391AFB8202EF
      //	Return a pointer to the ith independent parameter
      //	in the link string.
      const Parameter* independentParameter (int i) const;

      //## Operation: linkValue%391C601001ED
      Real linkValue () const;

      //## Operation: putLink%39243D83006E
      void putLink (std::ostream& s) const;

      //## Operation: clone%3A93F3940324
      ParameterLink* clone () const;

      //## Operation: findParam%3CA0905B01D4
      bool findParam (const Parameter* param) const;

      //## Operation: linkExpression%3FB92E6F035C
      string linkExpression (bool fullname) const;

      //## Operation: linkString%4460BDC3012B
      const LinkExpression& linkString () const;

      //## Operation: rerouteLink%4460C85D0361
      void rerouteLink (const std::vector<Parameter*>& newPars);

      //## Operation: regenerateExpression%4461F80F0327
      void regenerateExpression ();

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: FLAGVALUE%3A9292960137
      static const int& FLAGVALUE ();

      //## Attribute: members%49CD27170000
      const std::vector<const Parameter*>& members () const;
      void members (const std::vector<const Parameter*>& value);

  public:
    // Additional Public Declarations
      //## begin ParameterLink%362F93D90212.public preserve=yes
      //## end ParameterLink%362F93D90212.public

  protected:
    // Additional Protected Declarations
      //## begin ParameterLink%362F93D90212.protected preserve=yes
      //## end ParameterLink%362F93D90212.protected

  private:

    //## Other Operations (specified)
      //## Operation: swap%373B0D32E291;            C++
      void swap (ParameterLink& right);

      //## Operation: wordToParam%3918569E005B
      //	Interprets a "word" in the link expression as
      //	a parameter, and adds a map entry to the members list.
      bool wordToParam (const string& word);

      //## Operation: addPointer%391AD167039F
      bool addPointer (int num, const string& modelName = string("_DEFAULT"));

      //## Operation: wordToResponseParam%49CD281C0390
      //	Interprets a "word" in the link expression as a response
      //	parameter, and adds pointer to the members list.
      bool wordToResponseParam (const string& word);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: boolean%391B062D0124
      const bool boolean () const;

      //## Attribute: linkVal%39206A0502DB
      //	Current value of the link. Definitely useful for
      //	printing,
      //	and perhaps useful if the changed() flag is set and
      //	queried appropriately.
      //
      //	linkVal is set before exit of linkValue().
      const Real linkVal () const;
      void linkVal (Real value);

      //## Attribute: parent%39243A57007A
      const Parameter* parent () const;
      void parent (const Parameter* value);

    //## Get and Set Operations for Associations (generated)

      //## Association: XSUtil::Parse::<unnamed>%391C17160142
      //## Role: ParameterLink::linkString%391C17160146
      void linkString (LinkExpression value);

    // Additional Private Declarations
      //## begin ParameterLink%362F93D90212.private preserve=yes
      //## end ParameterLink%362F93D90212.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin ParameterLink::boolean%391B062D0124.attr preserve=no  private: bool {U} isBoolean
      bool m_boolean;
      //## end ParameterLink::boolean%391B062D0124.attr

      //## begin ParameterLink::linkVal%39206A0502DB.attr preserve=no  private: Real {U} 
      Real m_linkVal;
      //## end ParameterLink::linkVal%39206A0502DB.attr

      //## begin ParameterLink::parent%39243A57007A.attr preserve=no  private: const Parameter* {U} p
      const Parameter* m_parent;
      //## end ParameterLink::parent%39243A57007A.attr

      //## begin ParameterLink::FLAGVALUE%3A9292960137.attr preserve=no  public: static int {VC} -999
      static const int s_FLAGVALUE;
      //## end ParameterLink::FLAGVALUE%3A9292960137.attr

      //## begin ParameterLink::members%49CD27170000.attr preserve=no  public: std::vector<const Parameter*> {U} 
      std::vector<const Parameter*> m_members;
      //## end ParameterLink::members%49CD27170000.attr

    // Data Members for Associations

      //## Association: XSUtil::Parse::<unnamed>%391C17160142
      //## begin ParameterLink::linkString%391C17160146.role preserve=no  private: LinkExpression { -> 1VHgN}
      LinkExpression m_linkString;
      //## end ParameterLink::linkString%391C17160146.role

    // Additional Implementation Declarations
      //## begin ParameterLink%362F93D90212.implementation preserve=yes
      //## end ParameterLink%362F93D90212.implementation

};

//## begin ParameterLink%362F93D90212.postscript preserve=yes
//## end ParameterLink%362F93D90212.postscript

// Class ParameterLink::InvalidInput 

// Class ParameterLink::ParseFailure 

// Class ParameterLink::DivideCheck 

// Class ParameterLink::NoValidParametersInExpression 

// Class ParameterLink 


//## Other Operations (inline)
inline const Parameter* ParameterLink::independentParameter (int i) const
{
  //## begin ParameterLink::independentParameter%391AFB8202EF.body preserve=yes
  return m_members[i];    
  //## end ParameterLink::independentParameter%391AFB8202EF.body
}

inline const LinkExpression& ParameterLink::linkString () const
{
  //## begin ParameterLink::linkString%4460BDC3012B.body preserve=yes
   return m_linkString;
  //## end ParameterLink::linkString%4460BDC3012B.body
}

//## Get and Set Operations for Class Attributes (inline)

inline const bool ParameterLink::boolean () const
{
  //## begin ParameterLink::boolean%391B062D0124.get preserve=no
  return m_boolean;
  //## end ParameterLink::boolean%391B062D0124.get
}

inline const Real ParameterLink::linkVal () const
{
  //## begin ParameterLink::linkVal%39206A0502DB.get preserve=no
  return m_linkVal;
  //## end ParameterLink::linkVal%39206A0502DB.get
}

inline void ParameterLink::linkVal (Real value)
{
  //## begin ParameterLink::linkVal%39206A0502DB.set preserve=no
  m_linkVal = value;
  //## end ParameterLink::linkVal%39206A0502DB.set
}

inline const Parameter* ParameterLink::parent () const
{
  //## begin ParameterLink::parent%39243A57007A.get preserve=no
  return m_parent;
  //## end ParameterLink::parent%39243A57007A.get
}

inline void ParameterLink::parent (const Parameter* value)
{
  //## begin ParameterLink::parent%39243A57007A.set preserve=no
  m_parent = value;
  //## end ParameterLink::parent%39243A57007A.set
}

inline const int& ParameterLink::FLAGVALUE ()
{
  //## begin ParameterLink::FLAGVALUE%3A9292960137.get preserve=no
  return s_FLAGVALUE;
  //## end ParameterLink::FLAGVALUE%3A9292960137.get
}

inline const std::vector<const Parameter*>& ParameterLink::members () const
{
  //## begin ParameterLink::members%49CD27170000.get preserve=no
  return m_members;
  //## end ParameterLink::members%49CD27170000.get
}

inline void ParameterLink::members (const std::vector<const Parameter*>& value)
{
  //## begin ParameterLink::members%49CD27170000.set preserve=no
  m_members = value;
  //## end ParameterLink::members%49CD27170000.set
}

//## Get and Set Operations for Associations (inline)

inline void ParameterLink::linkString (LinkExpression value)
{
  //## begin ParameterLink::linkString%391C17160146.set preserve=no
  m_linkString = value;
  //## end ParameterLink::linkString%391C17160146.set
}

//## begin module%3A928ABE00C6.epilog preserve=yes
//## end module%3A928ABE00C6.epilog


#endif
